<template>
  <div>
    <transition name="fade">
      <div
        class="backdrop"
        v-if="navigationIsOpened"
        @click="toggleNavigation"
      ></div>
    </transition>
    <transition name="slide">
      <nav v-if="navigationIsOpened" @click="toggleNavigation">
        <ul>
          <router-link to="/profile" key="profile"> Profile </router-link>
          <router-link to="/payment" key="payment"> Payment </router-link>
        </ul>
      </nav>
    </transition>
    <button
      @click="toggleNavigation"
      :class="navigationIsOpened && 'nav-button--active'"
      class="nav-button"
    >
      <IHX v-if="navigationIsOpened" class="icon" />
      <IHBurger v-else class="icon" />
    </button>
  </div>
</template>

<script lang="ts" setup>
import { onMounted, onUnmounted, ref, watch } from "vue";
import IHX from "@/components/icons/IHX.vue";
import IHBurger from "@/components/icons/IHBurger.vue";

const navigationIsOpened = ref(false);
const windowSize = ref(0);

watch(
  () => windowSize.value,
  (value) => {
    if (value >= 1024) {
      navigationIsOpened.value = true;
    }
  },
  { immediate: true }
);

function toggleNavigation() {
  if (windowSize.value < 1024) {
    navigationIsOpened.value = !navigationIsOpened.value;
  }
}
onMounted(() => {
  windowSize.value = window.innerWidth;
  window.addEventListener("resize", () => {
    windowSize.value = window.innerWidth;
  });
});

onUnmounted(() => {
  window.removeEventListener("resize", () => {
    windowSize.value = window.innerWidth;
  });
});
</script>

<style scoped lang="scss">
.backdrop {
  position: fixed;
  top: 0;
  left: 0;
  width: 100vw;
  height: 100vh;
  background-color: black;
  opacity: 0.3;
  z-index: 50;

  @media (min-width: 1024px) {
    display: none;
  }
}

nav {
  height: 100vh;
  width: 190px;
  position: fixed;
  top: 0;
  left: 0;
  z-index: 100;
  overflow-y: auto;
  padding-bottom: 60px;
  border-right: 1px solid rgb(203 213 225);
  background-color: rgb(226 232 240);

  @media (min-width: 1024px) {
    padding-bottom: 10px;
  }

  ul {
    display: flex;
    flex-direction: column;
    padding: 10px 0 0 0;
    margin: 0;

    a {
      display: flex;
      align-items: center;
      justify-content: space-between;
      width: 100%;
      min-height: 40px;
      padding: 10px 20px 10px 10px;
      color: rgb(15 23 42);
      text-decoration: none;

      &:hover,
      &:focus {
        background-color: rgb(203 213 225);
        text-decoration: none;
      }
    }

    a.router-link-active {
      color: white;
      background-color: rgb(71 85 105);
    }
  }
}

.nav-button {
  position: fixed;
  top: 0;
  left: 0px;
  display: flex;
  align-items: center;
  justify-content: center;
  width: 44px;
  height: 44px;
  background-color: rgb(226 232 240);
  border-bottom: 1px solid rgb(203 213 225);
  border-right: 1px solid rgb(203 213 225);
  transition: all 0.3s ease;
  z-index: 50;
  box-shadow: 0 1px 2px 0 rgb(0 0 0 / 0.05);

  &--active {
    left: 190px;
  }

  @media (min-width: 1024px) {
    display: none;
  }
}

.fade-enter-active,
.fade-leave-active {
  transition: all 0.3s ease;
}

.fade-enter-from,
.fade-leave-to {
  opacity: 0;
}

.slide-enter-active,
.slide-leave-active {
  transition: all 0.3s ease;
}

.slide-enter-from,
.slide-leave-to {
  transform: translateX(-190px);
}


</style>
